;--------------------;
;---Projekt-Wrfel---;
;--------------------;

;Started at 20th of January 2012
Graphics 800,600,32,2
AppTitle "Projekt Punkte Klicker"

SeedRnd MilliSecs()

;-----------------------------------------------------Variablen, Dims und Types----------------------------------------------------;

Type Message
	Field Lives
	Field Cap$
End Type

Type Button
	Field X
	Field Y
	Field Width
	Field Heigth
	Field Cap$
	Field Enabled
	Field Clicked
End Type

;Spielfeld
Dim Map_Dim(5,1)

Global Timer			=	CreateTimer(30)
Global MausX			=	0
Global MausY			=	0
Global DimMausX			=	0
Global DimMausY			=	0
Global MouseState		=	0

;Name und Geld der Spieler
Global Player1Name$		=	""
Global Player2Name$		=	""
Global Player1Money		=	50
Global Player2Money		=	50
Global CurrPlayer		=	1 ;1=du 2=cpu

;Wrfel Variablen
Global Dice				=	1
Global Dice2			=	1
Global TotalDice			=	0
Global StartDice		=	False
Global DiceTimer		=	0
Global Wait 			=	False;Um den Wrfel nach einem Wurf unklickbar zu machen

;Positionen der Felder
Global OffsetX			=	102
Global OffsetY			=	402

;Wichtig fr das Menu
Global Menu				=	0
Global MP				=	False
Global Round			=	0
Global RoundStr$		=	""

;Buttons
Global Btn_SgP			=	CreateButton("Singel Player",400,210,45,True)
Global Btn_MP			=	CreateButton("Multi Player",400,255,45,True)
Global Btn_Ok			=	CreateButton("Ok",400,300,45,False)
Global Btn_Restart		=	CreateButton("Restart",400,255,45,False)
Global Btn_Menu			=	CreateButton("Men",400,300,45,False)

Global GameOver			=	False

Global Font=LoadFont("Wasser.ttf",45)
SetFont Font

;---------------------------------------------------Bilder erstellen---------------------------------------------------;

;Spielfeld
Global Map_Pic=LoadImage("Hintergrund.png")
MaskImage Map_Pic,255,0,255

Global Dice_Pic=LoadAnimImage("Wrfel.png",100,100,0,6)
MaskImage Dice_Pic,255,0,255


;-----------------------------------------------------Men Schleife----------------------------------------------------;

SetBuffer BackBuffer()
Color 0,0,$FF4E00

.Menue_Point
;Menu
Repeat 
	Cls
	
	MausX=MouseX()
	MausY=MouseY()
	
	If MouseHit(1) Then MouseState=1:FlushMouse
	DrawImage Map_Pic,0,0
	UpdateButton()
	
	;Zwischen Multiplayer und Singleplayer whlen
	If Menu=0 Then
		If GetButtonState(Btn_SgP) Then DeAktivAllButton(False):DeAktivButton(Btn_Ok,True):Menu=1
		If GetButtonState(Btn_MP) Then DeAktivAllButton(False):DeAktivButton(Btn_Ok,True):Menu=1:MP=True
	End If
	
	;Namen Sp1 eingeben
	If Menu=1 Then
		Text 400,210,"Nickname Player1:",True,True
		Text 400,255,Player1Name,True,True
		Key=GetKey()
		If Key>31 And Key<127 Then Player1Name=Player1Name+Chr$(Key)
		If Key=8 Then
			If Player1Name>"" Then Player1Name=Left(Player1Name,Len(Player1Name)-1)
		End If
		
		If Player1Name>"" Then
			If GetButtonState(Btn_Ok) Then
				If MP Then 
					Menu=2
				Else
					Menu=3
					
					;Namen auf Cpu setzen um gegen die Ki zu spielen
					Player2Name="Cpu"
				End If
			End If
		End If
	End If
	
	;Name Sp2 eingeben (Nur fr Multiplayer)
	If Menu=2 Then
		Text 400,210,"Nickname Player2:",True,True
		Text 400,255,Player2Name,True,True
		Key=GetKey()
		If Key>31 And Key<127 Then Player2Name=Player2Name+Chr$(Key)
		If Key=8 Then
			If Player2Name>"" Then Player2Name=Left(Player2Name,Len(Player2Name)-1)
		End If
		
		If Player2Name>"" Then
			If GetButtonState(Btn_Ok) Then Menu=3
		End If
	End If
	
	;Eingeben wie viele runden man spielen mchte
	If Menu=3 Then
		Text 400,210,"Wieviele Runden:",True,True
		Text 400,255,RoundStr,True,True
		Key=GetKey()
		If Key>47 And Key<58 Then RoundStr=RoundStr+Chr$(Key)
		If Key=8 Then
			If RoundStr>"" Then RoundStr=Left(RoundStr,Len(RoundStr)-1)
		End If
		
		If RoundStr>"" Then
			If GetButtonState(Btn_Ok) Then Round=RoundStr:DeAktivAllButton(False):Exit
		End If
	End If
	
	If MouseState>0 Then MouseState=0
	WaitTimer(Timer)
	Flip(0)
Forever

;-----------------------------------------------------Hauptschleife----------------------------------------------------;

While Not KeyHit(1)
	Cls
	
	;Speichert die Mausposition zwischen
	MausX=MouseX()
	MausY=MouseY()
	DimMausX=(MausX-OffsetX)/100
	DimMausY=(MausY-OffsetY)/100
	If MouseHit(1) Then MouseState=1:FlushMouse
	
	;Zeichnen der Map, des Geldes
	DrawImage Map_Pic,0,0
	UpdateButton()
	
	Color 0,0,$FF4E00
	
	;Updaten aller daten
	If GameOver=False Then
		ShowDice()
		If Wait=True Then SetPoint()
	Else
		;Wenn das Spiel vorbei ist
		If Player1Money>Player2Money Then Text 400,210,Player1Name+" hat gewonnen!",True,True
		If Player1Money=Player2Money Then Text 400,210,"Unentschieden! :|",True,True
		If Player1Money<Player2Money Then Text 400,210,Player2Name+" hat gewonnen!",True,True
		
		If GetButtonState(Btn_Restart) Then ResetGame(0)
		If GetButtonState(Btn_Menu) Then ResetGame(1):Goto Menue_Point
	End If
	
	;Anzeigen aller Daten
	Text 240,10,Player1Name+": "+Player1Money
	Text 240,55,Player2Name+": "+Player2Money
	Text 470,10,"Font by anke-art.de"
	Text 470,55,"Runden brig: "+Round
	If MouseState And RectsOverlap(MausX,MausY,1,1,470,10,StringWidth("Font by anke-art.de"),45) Then ExecFile("www.anke-art.de")
	
	ShowMessage()
	
	;Zeigt an Wieviele Punkte sich im jeweiligen Feld befinden
	Color 0,0,$9700FF
	For X=0 To 5
		Text OffsetX+X*100+20,OffsetY+75,Map_Dim(X,0),True,True
	Next
	For X=0 To 5
		Text OffsetX+X*100+20,OffsetY+175,Map_Dim(X,1),True,True
	Next
	
	If MouseState>0 Then MouseState=0
	WaitTimer(Timer)
	Flip(0)
Wend

WaitKey
End

;-----------------------------------------------------Paar Funktionen----------------------------------------------------;

;Button Funktionen
Function CreateButton(C$,X,Y,H,E)
	B.Button=New Button
	B\Cap=C
	B\X=X
	B\Y=Y
	B\Heigth=H
	B\Clicked=False
	B\Enabled=E
	
	Return Handle(B)
End Function

Function GetButtonState(ID)
	B.Button=Object.Button(ID)
	If B\Clicked=True Then B\Clicked=False:Return True
End Function

Function DeAktivButton(ID,E)
	B.Button=Object.Button(ID)
	B\Enabled=E
End Function

Function DeAktivAllButton(E)
	For B.Button=Each Button
		B\Enabled=E
	Next
End Function

Function UpdateButton()
	For B.Button=Each Button
		If B\Enabled Then
			Text B\X,B\Y,B\Cap,True,True
			If RectsOverlap(MausX,MausY,1,1,B\X-(StringWidth(B\Cap)/2),B\Y-22,StringWidth(B\Cap),B\Heigth) Then
				Rect B\X-(StringWidth(B\Cap)/2),B\Y-22,StringWidth(B\Cap),B\Heigth,False
				If MouseState Then B\Clicked=True
			End If
		End If
	Next
End Function

;-------------------------------------------------------------------------------------------------------------------------;

;Zufallszahlen
Function ShowDice()
	DrawImage Dice_Pic,10,10,Dice-1
	DrawImage Dice_Pic,120,10,Dice2-1
	
	;Der normale CurrPlayer
	If CurrPlayer=1 And Wait=False Then
		Text 10,130,Player1Name+" ist an der Reihe"
		If RectsOverlap(MausX,MausY,1,1,10,10,210,100) And MouseState=True And StartDice=False Then
			StartDice=True
		End If
	End If
	
	;Computer
	If CurrPlayer=2 And Wait=False Then
		Text 10,130,Player2Name+" ist an der Reihe"
		If Player2Name="Cpu" Then 
			If StartDice=False Then StartDice=True
		Else
			If RectsOverlap(MausX,MausY,1,1,10,10,210,100) And MouseState=True And StartDice=False Then
				StartDice=True
			End If
		End If
	End If
	
	;Setzt irgendwelche Zufallszahlen
	If StartDice=True Then
		DiceTimer=DiceTimer+1
		If DiceTimer=10 Then 
			Dice=Rand(1,6)
			Dice2=Rand(1,6)
			DiceTimer=0
			If Rand(0,10)=5 Then TotalDice=Dice+Dice2:Wait=True:StartDice=False
		End If
	End If
End Function

;Geld in eines der Felder setzbar machen
Function SetPoint()
	;Fr den Maximalwert
	Local Dim_PosX
	Local Dim_PosY
	
	If TotalDice>6 Then
		Dim_PosX=TotalDice-7
		Dim_PosY=1
	Else
		Dim_PosX=TotalDice-1
		Dim_PosY=0
	End If
	
	If CurrPlayer=1 Then 
		Text 10,130,"Sie knnen in Feld "+Dice
		Text 10,175,"oder in Feld "+TotalDice+" setzen"
		
		;Nur das Feld, dass den Wert des Haupwrfels oder den beider Wrfel zusammen anzeigt, anklickbar machen
		If RectsOverlap(MausX,MausY,1,1,OffsetX+((Dice-1)*100),OffsetY,100,100) Or RectsOverlap(MausX,MausY,1,1,OffsetX+(Dim_PosX*100),OffsetY+(Dim_PosY*100),100,100)Then
			Text 400,250,"Feld Geht",True,True
			If MouseState=1 Then 
				Map_Dim(DimMausX,DimMausY)=Map_Dim(DimMausX,DimMausY)+1
				Player1Money=Player1Money-1
				CheckArray()
			End If
		End If
	Else
		If Player2Name="Cpu" Then
			Ki()
			CheckArray()
		Else
			Text 10,130,"Sie knnen in Feld "+Dice
			Text 10,175,"oder in Feld "+TotalDice+" setzen"
			
			;Nur das Feld, dass den Wert des Haupwrfels oder den beider Wrfel zusammen anzeigt, anklickbar machen
			If RectsOverlap(MausX,MausY,1,1,OffsetX+((Dice-1)*100),OffsetY,100,100) Or RectsOverlap(MausX,MausY,1,1,OffsetX+(Dim_PosX*100),OffsetY+(Dim_PosY*100),100,100)Then
				Text 400,250,"Feld Geht",True,True
				If MouseState=1 Then 
					Map_Dim(DimMausX,DimMausY)=Map_Dim(DimMausX,DimMausY)+1
					Player2Money=Player2Money-1
					CheckArray()
				End If
			End If
		End If
	End If
End Function

;Computer
Function Ki()
	Local Setted
	
	;Fr den Maximalwert
	Local Dim_PosX
	Local Dim_PosY
	
	If TotalDice>6 Then
		Dim_PosX=TotalDice-7
		Dim_PosY=1
	Else
		Dim_PosX=TotalDice-1
		Dim_PosY=0
	End If
	
	DebugLog Map_Dim(Dim_PosX,Dim_PosY)
	
	;berprft ob das grte Feld nunoch 1nene Punkt braucht um voll zu sein, wenn das der Fall ist nimmt er es,
	If Map_Dim(Dim_PosX,Dim_PosY)=TotalDice-1 Then 
		Map_Dim(Dim_PosX,Dim_PosY)=Map_Dim(Dim_PosX,Dim_PosY)+1
		CreateMessage(Player2Name+" nahm Feld "+TotalDice)
		Setted=True
	End If
	
	;sonst berprft er den Hauptwrfel
	If Setted=False And Map_Dim(Dice-1,0)=Dice-1 Then 
		Map_Dim(Dice-1,0)=Map_Dim(Dice-1,0)+1
		CreateMessage(Player2Name+" nahm Feld "+Dice)
		Setted=True
	End If
	
	;Wenn beides nicht der Fall ist und bei beiden nurnoch 2 fehlen, so nimmt er das mit dem kleinsten wert
	If Setted=False And Map_Dim(Dice-1,0)=Dice-2 And Map_Dim(Dim_PosX,Dim_PosY)=TotalDice-2 Then 
		Map_Dim(Dice-1,0)=Map_Dim(Dice-1,0)+1
		CreateMessage(Player2Name+" nahm Feld "+Dice)
		Setted=True
	End If
	
	;Wenn nur einem der beiden nurnoch 2 fehlen, so nimmt er das andere
	If Setted=False Then
		If Map_Dim(Dice-1,0)=Dice-2 Then 
			Map_Dim(Dim_PosX,Dim_PosY)=Map_Dim(Dim_PosX,Dim_PosY)+1
			CreateMessage(Player2Name+" nahm Feld "+TotalDice)
			Setted=True
		End If
		
		If Map_Dim(Dim_PosX,Dim_PosY)=TotalDice-2 Then 
			Map_Dim(Dice-1,0)=Map_Dim(Dice-1,0)+1
			CreateMessage(Player2Name+" nahm Feld "+Dice)
			Setted=True
		End If
	End If
	
	;Wenn beide Felder wenig Punkte haben so nimmt er ein zuflliges
	If Setted=False And Map_Dim(Dice-1,0)<=Dice-2 And Map_Dim(Dim_PosX,Dim_PosY)<TotalDice-2 Then
		Select Rand(1,2)
			Case 1
				Map_Dim(Dim_PosX,Dim_PosY)=Map_Dim(Dim_PosX,Dim_PosY)+1
				CreateMessage(Player2Name+" nahm Feld "+TotalDice)
			Case 2
				Map_Dim(Dice-1,0)=Map_Dim(Dice-1,0)+1
				CreateMessage(Player2Name+" nahm Feld "+Dice)
		End Select
	End If
	
	Player2Money=Player2Money-1
End Function

;Schaut ob ein Feld seinen vollen Wert ereicht hat
Function CheckArray()
	Local TP;Total Points
	Local C;Counter
	
	;Felder auf Maximalwert berprfen
	If Map_Dim(5,1)=12 Then
		For Y=0 To 1
			For X=0 To 5
				TP=TP+Map_Dim(X,Y)
				Map_Dim(X,Y)=0
			Next
		Next
	End If
	
	For Y=0 To 1
		For X=0 To 5
			C=C+1
			If Map_Dim(X,Y)=C Then TP=TP+C:Map_Dim(X,Y)=0
		Next
	Next
	
	If CurrPlayer=1 Then
		If TP=1 Then
			CreateMessage(Player1Name+" hat den Joker genommen")
		Else If TP>1 And TP<13 Then
			CreateMessage(Player1Name+" hat "+TP+" Punkte gemacht")
		Else If TP>12 Then
			CreateMessage(Player1Name+" hat den Jackpot gemacht")
		End If
		Player1Money=Player1Money+TP
	Else
		If TP=1 Then
			CreateMessage(Player2Name+" hat den Joker genommen")
		Else If TP>1 And TP<13 Then
			CreateMessage(Player2Name+" hat "+TP+" Punkte gemacht")
		Else If TP>12 Then
			CreateMessage(Player2Name+" hat den Jackpot gemacht")
		End If
		
		Player2Money=Player2Money+TP
		
		;Runde um 1 verringern und wenn die letze war das Spiel beenden
		Round=Round-1
		If Round=0 Then GameOver=True:DeAktivButton(Btn_Restart,True):DeAktivButton(Btn_Menu,True)
	End If
	
	;Spieler nach jedem Durchgang wechseln
	Wait=0
	If CurrPlayer=1 Then 
		CurrPlayer=2
	Else
		CurrPlayer=1
	End If
End Function

;Resetted das Spiel
Function ResetGame(Ty=0)
	If Ty=1 Then 
		Player1Name		=	""
		Player1Money	=	50
		Player2Name		=	""
		Player2Money	=	50
		Round			=	0
		RoundStr		=	""
		Menu			=	0
		GameOver		=	False
		MP=False
		DeAktivAllButton(False)
		DeAktivButton(Btn_SgP,True)
		DeAktivButton(Btn_MP,True)
		
		Dim Map_Dim(5,1)
	Else
		Player1Money	=	50
		Player2Money	=	50
		Round			=	RoundStr
		GameOver		=	False
		
		DeAktivAllButton(False)
		Dim Map_Dim(5,1)
	End If
End Function

;-------------------------------------------------------------------------------------------------------------------------;

;Erstellt eine Nachricht
Function CreateMessage(T$)
	M.Message=New Message
	M\Lives=70
	M\Cap=T
End Function

;Zeigt eine erstellte Nachricht fr eine Bestimmte Zeit an
Function ShowMessage()
	For M.Message=Each Message
		M\Lives=M\Lives-1
		Color 0,0,$FFFFFF
		Rect 0,300-22,800,45,True
		Color 0,0,$000000
		Rect 0,300-22,800,45,False
		Text 400,300,M\Cap,True,True
		If M\Lives=0 Then Delete M
	Next
End Function
;~IDEal Editor Parameters:
;~F#E3#EF#F4#F9#FF#10E#133#163#1A8#1E0#1FE#205
;~C#Blitz3D