SuperStrict

Include "../Dices.bmx"

Global gfx_w:Int = 256, gfx_h:Int = 256
Graphics(gfx_w, gfx_h)
SeedRnd(MilliSecs())
SetClsColor(255, 255, 255)

Local dice:String[] = ["-6", "1d6", "4d4", "4d20+10", "2d4-10"]

Local Maxcount:Int = 1000, d:String = "1d4-2", n:Int
For Local i:Int = 0 Until Maxcount
	n:+Int(RollDice(d)[0])
Next

Cls
SetColor(0, 0, 0)
For Local i:Int = 0 Until dice.Length
	Local e:String[] = RollDice(dice[i])
	DrawText(dice[i] + ":", 8, 32 + i * 16)
	If e[1] Then
		DrawText(RSet(e[1] + " = " + e[0], 30), 8, 32 + i * 16)
	Else
		DrawText(RSet(e[0], 30), 8, 32 + i * 16)
	EndIf
Next

DrawText(d + " => " + (Float(n) / Float(Maxcount)), 8, 16)

Flip()
WaitKey()
End
