﻿Rem
	All das Zeug, das sonst kein Zusause hat und/oder
	im Editor gebraucht wurde.
Endrem

Const GS_Menu:Int = 0, GS_Play:Int = 1
Const GS_CharMenu:Int = 2, GS_CharMenu2:Int = 3, GS_LevelMenu:Int = 4
Const GS_UpgradeMenu:Int = 5
Global GameState:Int = GS_Menu

Function LoadText:String(_path:String)
	Local text:String
	Local file:TStream = ReadFile(_path)
	If file Then
		Repeat
			text:+file.ReadLine() + "~n"
		Until file.Eof()
		text = text[..text.length - 1]
		file.Close()
		Return text
	Else
		'* Dem Nutzer lieber etwas zeigen, als gar nichts:
		Return "Konnte~n{0F}" + StripDir(_path) + "{F0}~nnicht öffnen! {80}:("
	End If
End Function

Function DisplayText(_Path:String, _msg:String = "")
	Local text:String = LoadText(_Path)
	Cls
		DrawASCText(text, 1, 1)
		If _msg <> "" Then DrawASCText(_msg, 14, 23)
	Flip(0)
	Delay(100)
	FlushKeys()
	WaitKey()
End Function

Function LoadNames:String[] (_path:String)
	Local text:String[], names:String[]
	Local file:TStream = ReadFile(_path)
	If file Then
		Repeat
			text = file.ReadLine().Split(",")
			names = names[..] + text[..]
		Until file.Eof()

		file.Close()
		Return names
	Else
		'* Dem Nutzer lieber etwas zeigen, als gar nichts:
		names:+["NameFail"]
		Return names
	End If
End Function

Function LimitInt:Int(_value:Int, _min:Int, _max:Int)
	If _value < _Min Then
		Return _Min
	ElseIf _value > _Max Then
		Return _max
	Else
		Return _value
	EndIf
End Function

Function DistInt:Int(_x0:Int, _y0:Int, _x1:Int, _y1:Int)
 	'* Manhattan-Distanz:
	Return Abs(_x0 - _x1) + Abs(_y0 - _y1)
End Function

Function StringRepeat:String(_s:String, _n:Int)
	'* Kopiert den String '_s' '_n' mal
	Local re:String
	If _n < 0 Then Return ""
	For Local i:Int = 1 To _n
		re:+_s
	Next
	Return re
End Function