﻿Rem
	Kein schlechtes Mapformat, aber es hätte noch etwas ausgefeilter
	und variabler sein können. Für ein BCC ist es mehr als genug.
Endrem

Global Player:TPlayer = New TPlayer
Global Level:TLevel, Map:T42Map

Type TTileClass
	Field Index:Int
	Field Name:String
	Field Color:Int
	Field Symbols:Int[]
	Field Special:Int
	Rem
		-1 = Unbegehbar(aber durchsichtig) 
		0 = Boden
		1 = Hinderniss(undurchsichtig)
		2 = ọ̈ffenbar(undurchsichtig)
	Endrem
	
	Global Tiles:TTileClass[]
	Global Enemys:TTileClass[]
	
	Function Load(_Path:String)
		Local file:TStream = ReadFile(_path)
		If file Then
			file.ReadLine() '* Kommentarzeile
			
			Local TCounter:Int = 0
			Local ECounter:Int = 0
			Repeat
				Local line:String[] = file.ReadLine().Split(";")
				
				If line[0] = "ENEMY" Then
				    Local T:TTileClass = New TTileClass
					T.Index = ECounter
					ECounter:+1
					T.Name = line[1]
					Local e:TEnemyClass = TEnemyClass.GetClass(T.Name)
					T.Color = e.Color
					T.Symbols:+[e.Symbol]
					e = Null
					TTileClass.Enemys:+[T]
				ElseIf line[0] = "PLAYER" Or line[0] = "TARGET" Then
					Local T:TTileClass = New TTileClass
					T.Index = ECounter
					ECounter:+1
					Local e:TEnemyClass = TEnemyClass.GetClass(line[0])
					If e = Null Then
						e = New TEnemyClass
						e.Name = line[0]
						e.Color = Int(line[1])
						e.Symbol = Int(line[2])
					End If
					T.Name = e.Name
					T.Color = e.Color
					T.Symbols:+[e.Symbol]
					e = Null
					TTileClass.Enemys:+[T]
				Else
					Local T:TTileCLass = New TTileCLass
					T.Index = TCounter
					TCounter:+1
					T.Name = line[0]
					T.Color = Int(line[1])
					
					If line[2].Find("-") > - 1 Then
						Local tmp:String[] = line[2].Split("-")
						For Local i:Int = Int(tmp[0]) To Int(tmp[1])
							T.Symbols:+[i]
						Next
					ElseIf line[2].Find(",") > - 1 Then
						Local tmp:String[] = line[2].Split(",")
						For Local i:Int = 0 Until tmp.Length
							T.Symbols:+[Int(tmp[i])]
						Next
					Else
						T.Symbols:+[Int(line[2])]
					End If
					
					T.Special = Int(line[3])
					TTileCLass.Tiles:+[T]
				EndIf
			
			Until file.Eof()
			
			file.Close()
		Else
			RuntimeError("~nTTileCLass~nLoad() no~n" + StripDir(_Path))
		EndIf
	End Function
	
End Type

Type TTile
	Field Symbol:Int
	Field Color:Int
	Field Class:TTileCLass
	Field Special:Int
	
	Function Create:TTile(_Class:TTileCLass)
		Local T:TTile = New TTile
			T.Class = _Class
			T.Color = _Class.Color
			T.Symbol = _Class.Symbols[0]
			T.Special = _Class.Special
		Return T
	End Function
	
End Type

Type T42Map
	Const XSize:Int = 32
	Const YSize:Int = 22
	
	Field MissionPath:String
	Field Map:TTile[XSize, YSize]
	Field EMap:TEnemyClass[XSize, YSize]
	Field LightMap:Int[XSize, YSize] '* 0=Schwarz, 1 = Bekannt/Grau, 2=Gerade beleuchtet
	Field EndTile:TList
	
	Function Create:T42Map()
		Local M:T42Map = New T42Map
		
		For Local y:Int = 0 Until YSize
			For Local x:Int = 0 Until XSize
				M.Map[x, y] = TTile.Create(TTileClass.Tiles[0])
			Next	
		Next
		
		Return M
	EndFunction
	
	Method ComeToLifeBySatansUnholyPower()
		For Local y:Int = 0 Until YSize
			For Local x:Int = 0 Until XSize
				If Self.EMap[x, y] = Null Then Continue
				Select Self.EMap[x, y].name
					Case "PLAYER"  '* Hardcoding, weil ich nicht ~jeden~ BS extern definiere. Will auch mal fertig werden.
						Player.x = x
						Player.y = y
					Case "TARGET"
						If Self.EndTile = Null Then Self.EndTile = New TList
						Self.EndTile.AddLast(Self.Map[x, y])
					Default
						Local e:TEnemyClass = TEnemyClass.GetClass(Self.EMap[x, y].name)
						If e Then
							TEnemy.Create(e, x, y)
						EndIf
				End Select
			Next
		Next
		
		?Debug
			If Self.EndTile = Null And TEnemy.List.Count() = 0 Then RuntimeError("No way to win!")
			If Player.x = -1 Then RuntimeError("No Player!")
		?
		If Self.EndTile = Null And TEnemy.List.Count() = 0 Then Notify("No way to win!", True) ;End
		If Player.x = -1 Then Notify("No Player!", True);End
	EndMethod
	
	Method Draw()
		For Local y:Int = 0 Until YSize
			For Local x:Int = 0 Until XSize
			
				If Self.LightMap[x, y] = 2 Then
					ASC_Color(Self.Map[x, y].Color & $F)
					DrawImage(Ascii, x * TileSize, y * TileSize, $DB)
					ASC_Color((Self.Map[x, y].Color & $F0) / $10)
					DrawImage(Ascii, x * TileSize, y * TileSize, Self.Map[x, y].Symbol)
				ElseIf Self.LightMap[x, y] = 1 Then
					ASC_Color($2)
					DrawImage(Ascii, x * TileSize, y * TileSize, Self.Map[x, y].Symbol)
				EndIf

			Next
		Next	
	End Method
	
	Method AndGodSaidLetThereBeLight(_x:Int, _y:Int, _r:Int)
		Self.AndGodDividedTheLightFromTheDarkness()
		
		If _x = -1 Then _x = Rand(_r, T42Map.XSize - (_r + 1))
		If _y = -1 Then _y = Rand(_r, T42Map.YSize - (_r + 1))
		
		rem
		For Local w:Int = 0 Until 360 Step 6
			Self.ShineTheLightOfTheLORD(_x, _y, _x + Cos(w) * _r, _y + Sin(w) * _r)
		Next
		endrem
		
		For Local i:Int = -_r To _r
			Self.ShineTheLightOfTheLORD(_x, _y, _x - _r, _y + i)
			Self.ShineTheLightOfTheLORD(_x, _y, _x + _r, _y + i)
			Self.ShineTheLightOfTheLORD(_x, _y, _x + i, _y - _r)
			Self.ShineTheLightOfTheLORD(_x, _y, _x + i, _y + _r)
		Next

	EndMethod
	
	Method ShineTheLightOfTheLORD(x0:Int, y0:Int, x1:Int, y1:Int)
		Local dx:Int = Abs(x1 - x0)
		Local dy:Int = Abs(y1 - y0)
		Local sx:Int, sy:Int, err:Int, e2:Int
		If x0 < x1 Then sx = 1 Else sx = -1
		If y0 < y1 Then sy = 1 Else sy = -1
		err = dx - dy
		
		Repeat
			Local xc:Int = LimitInt(x0, 0, T42Map.XSize - 1)
			Local yc:Int = LimitInt(y0, 0, T42Map.YSize - 1)
			
			Self.LightMap[xc, yc] = 2
			If Self.Map[xc, yc].Special > 0 Then Exit

			If x0 = x1 And y0 = y1 Exit
			
		    e2 = 3 * err
		    If e2 > - dy Then
			    err = err - dy
			    x0 = x0 + sx
		    EndIf
			If e2 < dx Then
			    err = err + dx
			    y0 = y0 + sy
		    EndIf
		Forever
		
	EndMethod

	Method AndGodDividedTheLightFromTheDarkness()
		For Local y:Int = 0 Until YSize
			For Local x:Int = 0 Until XSize
				If Self.Lightmap[x, y] = 2 Then Self.Lightmap[x, y] = 1
			Next
		Next		
	EndMethod
	
	Method CheckWin:Int()
		If Self.EndTile = Null Then
			If TEnemy.List.Count() = 0 Then Return True
		Else
			For Local T:TTile = EachIn Self.EndTile
				If T = Self.Map[Player.x, Player.y] Return True
			Next
		End If
		Return False
	End Method
		
	Function Load:T42Map(_Path:String)
		Local file:TStream = ReadFile(_path)
		If file Then
			Local M:T42Map = New T42Map

			M.MissionPath = file.ReadLine()
			For Local y:Int = 0 Until YSize
				For Local x:Int = 0 Until XSize
					M.Map[x, y] = TTile.Create(TTileCLass.Tiles[file.ReadInt()])
					M.Map[x, y].Symbol = file.ReadInt()
				Next	
			Next
			While Not(file.Eof())
				Local n:String = file.ReadLine()
				Local y:Int = file.ReadInt()
				Local x:Int = file.ReadInt()
				M.EMap[x, y] = TEnemyClass.GetClass(n)
			Wend
			
			file.Close()
			Return M
		Else
			RuntimeError("~nT42Map~nLoad() no~n" + StripDir(_Path))
		EndIf
	EndFunction
	
	Function Save(M:T42Map, _Path:String, _MissionPath:String)
		If M = Null Then Return
		If _Path = "" Then Return
		Local file:TStream = WriteFile(_path)
		If file Then

			If _MissionPath <> "STD" Then
				Local pos:Int = _MissionPath.Find("Data")
				If pos <> - 1 Then _MissionPath = _MissionPath[pos.._MissionPath.length]
			EndIf
		
			file.WriteLine(_MissionPath)
			For Local y:Int = 0 Until YSize
				For Local x:Int = 0 Until XSize
					file.WriteInt(M.Map[x, y].Class.Index)
					file.WriteInt(M.Map[x, y].Symbol)
				Next
			Next
			For Local y:Int = 0 Until YSize
				For Local x:Int = 0 Until XSize
					If M.EMap[x, y] <> Null Then
						file.WriteLine(M.EMap[x, y].name)
						file.WriteInt(y)
						file.WriteInt(x)
					End If
				Next
			Next
			
			file.Close()
			Return
		Else
			RuntimeError("~nT42Map~nSave() no~n" + StripDir(_Path))
		EndIf	
	EndFunction

End Type
